package info.kwarc.lmh.DefIndexer;

import info.kwarc.mmt.MMT;

import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.solr.client.solrj.SolrServer;
import org.apache.solr.client.solrj.SolrServerException;
import org.apache.solr.client.solrj.impl.HttpSolrServer;
import org.apache.solr.common.SolrInputDocument;

public class DefIndexer {

	public DefIndexer() {
	}

	final static Pattern uri  = Pattern.compile("http://mathhub.info/([\\w-]+)/([\\w-]+)/([\\w-\\./]+)\\?([\\w-.]+)(\\?([\\w-.]+))?");
	
	public static void main(String[] args) {
		String urlString = "http://mathhub.info:8983/solr";
		SolrServer solr = new HttpSolrServer(urlString);

		try {
			solr.deleteByQuery( "*:*" );
		} catch (SolrServerException e1) {
			e1.printStackTrace();
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		MMT mmt = new MMT("http://mathhub.info:8080");

		for (String theoryURI : mmt.getTheories()) {
			String content = mmt.getPresentation(theoryURI);
			for (String concept : mmt.getTheoryConcepts(theoryURI)) {
				SolrInputDocument doc = new SolrInputDocument();
				Matcher m = uri.matcher(concept);
				if (!m.matches()) {
					continue;
				}
				
				String repo_group = m.group(1);
				String repo_name = m.group(2);
				String repo = repo_group+"/"+repo_name;
				String omdoc = m.group(3);
				String theory = m.group(4);
				String symb = m.group(6);

				doc.addField( "id", concept, 1.0f );
				doc.addField( "repository", repo, 1.0f );
				doc.addField( "repository_name", repo_name, 1.0f );
				doc.addField( "repository_group", repo_group, 1.0f );
				
				doc.addField( "omdoc", omdoc, 1.0f );
				doc.addField( "theory", theory, 1.0f );
				doc.addField( "symbol", symb, 1.0f );
				doc.addField( "content", content, 1.0f );
				
				try {
					solr.add(doc);
				} catch (SolrServerException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}		
			}
		}
		
		try {
			solr.commit();
		} catch (SolrServerException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}
}
